## luajit 2.0.0~beta4+dfsg

=== Makefile ===
--- 
+++ 
@@ -9,13 +9,13 @@
 # For MinGW and Cygwin, cd to src and run make with the Makefile there.
 # NYI: add wininstall.bat
 #
-# Copyright (C) 2005-2009 Mike Pall. See Copyright Notice in luajit.h
+# Copyright (C) 2005-2010 Mike Pall. See Copyright Notice in luajit.h
 ##############################################################################
 
 MAJVER=  2
 MINVER=  0
 RELVER=  0
-PREREL=  -beta2
+PREREL=  -beta4
 VERSION= $(MAJVER).$(MINVER).$(RELVER)$(PREREL)
 ABIVER=  5.1
 NODOTABIVER=  51
