## luajit 2.0.0~beta5+dfsg

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 MAJVER=  2
 MINVER=  0
 RELVER=  0
-PREREL=  -beta4
+PREREL=  -beta5
 VERSION= $(MAJVER).$(MINVER).$(RELVER)$(PREREL)
 ABIVER=  5.1
 NODOTABIVER=  51
