=== debian/changelog ===
luajit (2.0.0~beta5+dfsg-1) unstable; urgency=low

  * new upstream release

 -- Enrico Tassi <gareuselesinge@debian.org>  Wed, 25 Aug 2010 09:40:46 +0200
