=== debian/changelog ===
luajit (2.0.0~beta6+dfsg-1) unstable; urgency=low

  * new upstream release
  * watch file updated 
  * updated standards-version to 3.9.1, no change needed
  * updated copyright (extends to 2011)

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 13 Feb 2011 13:22:20 +0100
