=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Enrico Tassi <gareuselesinge@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), lua5.1, quilt (>= 0.46-7~)
-Standards-Version: 3.8.4
+Standards-Version: 3.9.1
 Vcs-Svn: svn://svn.debian.org/pkg-lua/packages/luajit
 Vcs-Browser: http://svn.debian.org/viewsvn/pkg-lua/packages/luajit
 Homepage: http://luajit.org
